<?php
/*
Plugin Name: Blogstamp
Plugin URI: http://www.extremeambient.net/blogstamp/
Description: Creates and validates notarized/certified timestamps for character based content in http://blogstamp.org/blogstamp/. It is based on Matt Flemings Drupal Blogstamp Module
Version: 0.1
Author: ExtremeAmbient Comunity
Author URI: http://www.extremeambient.net
*/

if (defined('WPLANG') && '' != constant('WPLANG')) {
  load_plugin_textdomain('blogstamp', 'wp-content/plugins/blogstamp');
}

function eac_blogstamp_install() {
	global $wpdb, $eac_text, $table_prefix;

	$query = 'CREATE TABLE IF NOT EXISTS ' . $table_prefix . 'blogstamp (
			ID bigint(20) unsigned NOT NULL,
			created varchar(20) NOT NULL,
			signature text NOT NULL,
			PRIMARY KEY (ID)
		) TYPE=MyISAM;';
	$wpdb->hide_errors();
	$wpdb->query($query);
	if ($wpdb->result !== false) {
		return true;
	}
	return false;
}

function eac_blogstamp_installed() {
	global $wpdb, $table_prefix;
	
	$wpdb->hide_errors();
	
	$query = 'SELECT ID FROM ' . $table_prefix . 'blogstamp LIMIT 1;';
	$wpdb->get_var($query);
	
	if ($wpdb->result !== false) {
		return true;
	}
	
	if (eac_blogstamp_install() === true) {
		return true;
	}
	return false;
}

function eac_clear_content($content) {
	return remove_accents(str_replace(array("\r\n", "\r", "\n"), "", $content));
}

function eac_request_signature($content) {
	global $wp_version;

	$eac_host = 'blogstamp.org';
	$eac_port = 80;
	$eac_protocol = '';
	$eac_http_file = 'blogstamp/stamp';
	$eac_http_response = '';
	$eac_http_request = '';
	
	if ($eac_config_data['protocol'] === 'SSL') {
		$eac_protocol = 'ssl://';
		$eac_port = 443;
	}
	
	$content = eac_clear_content($content);
	
	$eac_http_request .= 'POST /' . $eac_http_file . ' HTTP/1.0' . "\r\n";
	$eac_http_request .= 'Host: ' . $eac_host . "\r\n";
	$eac_http_request .= 'Content-Type: text/plain; charset=' . get_settings('blog_charset') . "\r\n";
	$eac_http_request .= 'Content-Length: ' . strlen($content) . "\r\n";
	$eac_http_request .= 'User-Agent: WordPress/' . $wp_version . "\r\n";
	$eac_http_request .= "\r\n";
	$eac_http_request .= $content;

	if (($eac_fs = @fsockopen($eac_protocol . $eac_host, $eac_port, $eac_errno, $eac_errstr, 5)) !== false) {
		fwrite($eac_fs, $eac_http_request);
		while (!feof($eac_fs)) {
			$eac_http_response .= fgets($eac_fs, 1160);
		}
		fclose($eac_fs);
		
		$eac_signature = explode("\r\n\r\n", $eac_http_response);
		$eac_signature = $eac_signature[1];
		$eac_http_response = explode("\r\n", $eac_http_response);
		
		if ($eac_http_response) {
			$eac_timestamp = 0;
			foreach ($eac_http_response as $eac_line) {
				if (ereg('(timestamp: )(.*)', $eac_line, $eac_ereg_response)) {
					$eac_timestamp = $eac_ereg_response[2];
					break;
				}
			}
		}
		return array('timestamp' => $eac_timestamp, 'signature' => $eac_signature);
	}
	return false;
}

function eac_blogstamp_exits($id) {
	global $wpdb, $table_prefix;

	if (!isset($id)) {
   $id = $_REQUEST['post_ID'];
	}
	$wpdb->hide_errors();
	$query = "SELECT ID FROM " . $table_prefix . "blogstamp WHERE ID = '$id' LIMIT 1;";
	$ID = $wpdb->get_var($query);
	
	if (intval($ID)) {
		return true;
	}
	
	return false;
}

function eac_create_form($id) {
	global $wpdb, $eac_text, $table_prefix;

	if (empty($id)) {
		$id = $_GET['id'];
	}
	
	if (eac_blogstamp_exits($id) === true) {
		if (($post = get_post($id)) !== null) {
			
			$eac_post_content = htmlspecialchars(eac_clear_content($post->post_content));
			$eac_post_date_gmt = $post->post_date_gmt;
			$eac_post_modified_gmt = $post->post_modified_gmt;
			
			$query = "SELECT signature, created FROM " . $table_prefix . "blogstamp WHERE ID = '$id' LIMIT 1;";
			$eac_db_requested_data = $wpdb->get_results($query);
			$eac_db_requested_data = $eac_db_requested_data[0];
			
			$eac_blogstamp_signature = $eac_db_requested_data->signature;
			$eac_blogstamp_created = $eac_db_requested_data->created;
	
			echo '<p>' . __('Use this form to ensure that the content has been published in the indicated date and / or it has not been modified since was it was publishe. In case the creation and the last update date are different, the last one will be the reference date. Press "Check signature" and you will be redirected (in a new window) to the blogstamo server which creates the timestamp.', 'blosgatmp');
			echo '<form action="https://blogstamp.org/blogstamp/validate" method="post" id="your_form_id" target="_blank">';
			echo '<label for="edit-timestamp_display"><small>' . __('Creation timestamp:', 'blogstamp') . ' </small></label><br />' . "\r\n";
			echo '<input type="text" name="edit[timestamp_display]" id="edit-timestamp_display" class="text2" size="22" value="'. $eac_post_date_gmt . '" readonly /><br/><br/>' . "\r\n";
			echo '<label for="edit-timestamp_update"><small>' . __('Last update timestamp:', 'blogstamp') . ' </small></label><br />' . "\r\n";
			echo '<input type="text" name="edit[timestamp_update]" id="edit-timestamp_update" class="text2" size="22" value="'. $eac_post_modified_gmt . '" readonly /><br/><br/>' . "\r\n";
			echo '<label for="edit-created"><small>' . __('Signature creation timestamp:', 'blogstamp') . ' </small></label><br />' . "\r\n";
			echo '<input type="text" name="edit[created]" id="edit-created" class="text2" size="22" value="' . date("Y-m-d H:i:s", substr($eac_blogstamp_created, 0, -3)) . '" readonly /><input type="hidden" name="edit[timestamp]" id="edit-timestamp" value="' . $eac_blogstamp_created . '" /><br /><br />' . "\r\n";
			echo '<label for="edit-body"><small>' . __('Content:', 'blogstamp') . ' </small></label><br />' . "\r\n";
			echo '<textarea cols="60" rows="10" name="edit[body]" id="edit-body" readonly>' . $eac_post_content . '</textarea><br/><br/>' . "\r\n";
			echo '<label for="edit-signature"><small>' . __('Signature:', 'blogstamp') . ' </small></label><br />' . "\r\n";
			echo '<textarea cols="60" rows="7" name="edit[signature]" id="edit-signature" readonly>' . $eac_blogstamp_signature . '</textarea><br /><br />' . "\r\n";
			echo '<input name="submit" type="submit" class="button" value="' . __('Check signature', 'blogstamp') . '" /><br /><br/></form>';
		}
	}
	echo '<a href="http://www.extremeambient.net/blogstamp" title="Blogstamp plugin for Wordpress" target="_blank">Blogstamp plugin for Wordpress</a><br/><br/>';
}

function eac_link($content) {
	global $wpdb, $id, $eac_text;
	
	if (eac_blogstamp_installed() === true) {
		if (eac_blogstamp_exits($id) === true) {
			$eac_blogstamp_page = get_option('eac_blogstamp_page');
			$content .= '<br /><a href="' . get_bloginfo('url') . '/' . $eac_blogstamp_page . '/?id=' . $id . '" target="_blank" title="' . __('Check timestamp created by blogstamp.org', 'blogstamp') . '">' . __('Timestamp certified', 'blogstamp') . '</a><br />';
		}
		return $content;
	}
}

function eac_new_blogstamp($id) {
	global $wpdb, $table_prefix;
	
	if (eac_blogstamp_installed() === true) {
		if (!isset($id)) {
	  	$id = $_REQUEST['post_ID'];
		}
		
		if (($post = get_post($id)) !== null) {
			if (($eac_requested_signature = eac_request_signature($post->post_content)) !== false) {
				
				$wpdb->hide_errors();
				
				$query = "INSERT INTO " . $table_prefix . "blogstamp (ID, created, signature) VALUES ('$id', '{$eac_requested_signature['timestamp']}', '{$eac_requested_signature['signature']}');";
				$wpdb->query($query);

				$query = "UPDATE " . $table_prefix . "blogstamp SET created = '{$eac_requested_signature['timestamp']}', signature = '{$eac_requested_signature['signature']}' WHERE ID = '$id' LIMIT 1;";
				$wpdb->query($query);
			}
		}
	}
}

function eac_blogstamp_panel() {
	
	if (isset($_POST['submit_protocol']) && !empty($_POST['submit_protocol'])) {
		update_option('eac_blogstamp_protocol', mysql_escape_string($_POST['submit_protocol']));
	}
	
	if (isset($_POST['page_name']) && !empty($_POST['page_name'])) {
		update_option('eac_blogstamp_page', mysql_escape_string($_POST['page_name']));
	}
	
	
	$eac_blogstamp_protocol = get_option('eac_blogstamp_protocol');
	$eac_blogstamp_page = get_option('eac_blogstamp_page');
	
	
	echo '<div class="wrap">';
	echo '<form method="post" action="' . $_SERVER['PHP_SELF'] . '?' . $_SERVER['QUERY_STRING'] . '">';
	echo '<h2>';_e('Blogstamp');echo '</h2>';
	echo '<fieldset class="options">';
  echo '<legend>General settings</legend>';
  echo '<table width="100%" cellspacing="2" cellpadding="5" class="editform">';
  echo '<tr>';
  echo '<th nowrap valign="top" width="33%">' . __('Protocol', 'blogstamp') . '</th>';
  echo '<td>';
  echo '<select name="submit_protocol" id="submit_protocol">';
  echo '<option value="HTTP"';if ($eac_blogstamp_protocol !== 'SSL') echo ' selected';echo '>HTTP</option>';
  echo '<option value="SSL"';if ($eac_blogstamp_protocol === 'SSL') echo ' selected';echo '>SSL</option>';
  echo '</select>';
  echo '<br />' . __('Protocol througth a new signature is requested. Some servers do not allow to use SSL protocol through sockets. If yours does not allow, use HTTP.', 'blogstamp');
  echo '</td>';
	echo '</tr>';
	echo '<tr>';
	echo '<th nowrap valign="top" width="33%">' . __('Page name', 'blogstamp') . '</th>';
	echo '<td>';
	echo '<input type="text" name="page_name" id="page_name" value="' . $eac_blogstamp_page . '" />';
	echo '<br />' . __('The page where the blogstamp validation form will be place.', 'blogstamp');
	echo '</td>';
	echo '</tr>';
	echo '</table>';
	echo '</fieldset>';
	echo '<div class="submit">';
	echo '<input type="submit" name="info_update" value="' . __('Update settings', 'blogstamp') . '" />';
	echo '</div>';
	echo '</form>';
	echo '</div>';
}

function eac_blogstamp_config() {
	add_options_page('Blogstamp configuration', 'Blogstamp', 8, basename(__FILE__), 'eac_blogstamp_panel');
}

add_action('admin_menu', 'eac_blogstamp_config');
add_action('publish_post', 'eac_new_blogstamp', 3);
add_filter('the_content', 'eac_link', 3);

add_option('eac_blogstamp_protocol', 'HTTP', 'Protocol througth a new signature is requested', 'yes');
add_option('eac_blogstamp_page', 'blogstamp', 'The page where the blogstamp validation form will be place', 'yes');
?>